#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <limits.h>
#include <locale.h>
#define SOUBOR "DTW.txt"
#define MAX_DELKA_RETEZCE 1024
#define POCATEK_BACK_TRACKING '0'

typedef struct {
  char s[MAX_DELKA_RETEZCE];
  int delka;
} RETEZEC;

typedef struct {
  int distance;
  char back_tracking;
} PRVEK_MED;

void precti_retezec(RETEZEC *text, FILE *fr)
{
  char c;
  fgets(text->s, MAX_DELKA_RETEZCE, fr);
  text->delka = strlen(text->s) - 1;
  if (text->s[text->delka] == '\n')
    text->s[text->delka] = '\0';
  else {
    (text->delka)++;
    while ((c = getc(fr)) != '\n' && c != EOF)
      ;
  }
  printf("\"%s\" - %d znaku\n", text->s, text->delka);
}

int main()
{
  FILE *f;
  RETEZEC s1, s2;
  PRVEK_MED **matice_MED, *p_matice_MED;
  int i, j, min, pocet_M = 0, pocet_D = 0, pocet_I = 0, pocet_S = 0;
  setlocale(LC_ALL,""); //https://www.cplusplus.com/reference/clocale/setlocale/
  if ((f = fopen(SOUBOR, "r")) == NULL) {
    printf("Soubor %s se nepodarilo otevrit.\n", SOUBOR);
    return 1;
  }
  precti_retezec(&s1, f);
  precti_retezec(&s2, f);
  if (fclose(f) == EOF) {
    printf("Soubor %s se nepodarilo uzavrit.\n", SOUBOR);
    return 1;
  }
  if ((f = fopen(SOUBOR, "a")) == NULL) {
    printf("Soubor %s se nepodarilo otevrit.\n", SOUBOR);
    return 1;
  }
  p_matice_MED = (PRVEK_MED *) malloc((s1.delka + 1) * (s2.delka + 1) * sizeof(PRVEK_MED));
  matice_MED = (PRVEK_MED **) malloc((s1.delka + 1) * sizeof(PRVEK_MED *));
  for (i = 0; i <= s1.delka; i++) {
    matice_MED[i] = p_matice_MED + i * (s2.delka + 1);
  }
  for (i = 0; i <= s1.delka; i++) {
    matice_MED[i][0].distance = i;
  }
  for (j = 1; j <= s2.delka; j++) {
    matice_MED[0][j].distance = j;
  }
  matice_MED[0][0].back_tracking = POCATEK_BACK_TRACKING;
  for (i = 1; i <= s1.delka; i++) {
    matice_MED[i][0].back_tracking = 'd';
  }
  for (j = 1; j <= s2.delka; j++) {
    matice_MED[0][j].back_tracking = 'i';
  }
  for (i = 1; i <= s1.delka; i++) {
    for (j = 1; j <= s2.delka; j++) {
      min = INT_MAX;
      if (s1.s[i-1] == s2.s[j-1]) {
        if (matice_MED[i-1][j-1].distance < min) {
          min = matice_MED[i-1][j-1].distance;
          matice_MED[i][j].back_tracking = 'm';
        }
      } else {
          if (matice_MED[i-1][j].distance + 1 < min) {
            min = matice_MED[i-1][j].distance + 1;
            matice_MED[i][j].back_tracking = 'd';
          }
          if (matice_MED[i][j-1].distance + 1 < min) {
            min = matice_MED[i][j-1].distance + 1;
            matice_MED[i][j].back_tracking = 'i';
          }
          if (matice_MED[i-1][j-1].distance + 1 < min) {
            min = matice_MED[i-1][j-1].distance + 1;
            matice_MED[i][j].back_tracking = 's';
          }
        }
      matice_MED[i][j].distance = min;
    }
  }
  i = s1.delka;
  j = s2.delka;
  do {
    matice_MED[i][j].back_tracking = toupper(matice_MED[i][j].back_tracking);
    switch (matice_MED[i][j].back_tracking) {
      case 'M': i--; j--; pocet_M++; break;
      case 'D': i--;      pocet_D++; break;
      case 'I':      j--; pocet_I++; break;
      case 'S': i--; j--; pocet_S++; break;
    }
  } while (matice_MED[i][j].back_tracking != POCATEK_BACK_TRACKING);
  fprintf(f, "\n");
  for (i = s1.delka; i >= 1; i--) {
    fprintf(f, "%c\t", s1.s[i-1]);
      for (j = 0; j <= s2.delka; j++) {
        fprintf(f, "%d\t", matice_MED[i][j].distance);
      }
      fprintf(f, "\n");
  }
  fprintf(f, "\t");
  for (j = 0; j <= s2.delka; j++) {
    fprintf(f, "%d\t", matice_MED[0][j].distance);
  }
  fprintf(f, "\n\t\t");
  for (j = 1; j <= s2.delka; j++) {
    fprintf(f, "%c\t", s2.s[j-1]);
  }
  fprintf(f, "\n\n");
  for (i = s1.delka; i >= 1; i--) {
    fprintf(f, "%c\t", s1.s[i-1]);
      for (j = 0; j <= s2.delka; j++) {
        fprintf(f, "%c\t", matice_MED[i][j].back_tracking);
      }
      fprintf(f, "\n");
  }
  fprintf(f, "\t");
  for (j = 0; j <= s2.delka; j++) {
    fprintf(f, "%c\t", matice_MED[0][j].back_tracking);
  }
  fprintf(f, "\n\t\t");
  for (j = 1; j <= s2.delka; j++) {
    fprintf(f, "%c\t", s2.s[j-1]);
  }
  fprintf(f, "\n\n");
  fprintf(f, "Pocet pismen:\t%d\n", s1.delka);
  fprintf(f, "Matches M =\t%d\n", pocet_M);
  fprintf(f, "Deletions D =\t%d\n", pocet_D);
  fprintf(f, "Insertions I =\t%d\n", pocet_I);
  fprintf(f, "Substitutions S =\t%d\n", pocet_S);
  free((void *) p_matice_MED);
  free((void *) matice_MED);
  if (fclose(f) == EOF) {
    printf("Soubor %s se nepodarilo uzavrit.\n", SOUBOR);
    return 1;
  }
  return 0;
}
